#ifndef GRIPPER_H
#define GRIPPER_H

#include <plib/sg.h>
#include "file.h"

#define SWT_NUM_GRIPPERS 3
#define TAC_NUM_GRIPPERS 3
#define BF1_NUM_GRIPPERS 3
#define GUN_NUM_GRIPS 2

typedef struct {
  unsigned short name_length;
  char *name;
  sgMat4 local;
  unsigned short bone_id;
  sgMat4 world;
} gripper_t;

int read_grippers(FILE *, unsigned short *, gripper_t **);
int write_grippers(FILE *, unsigned short *, gripper_t **);
void cleanup_grippers(unsigned short, gripper_t *);

/* Create default grippers */
int make_swt_gripper(gripper_t &, unsigned short);
int make_kid_gripper(gripper_t &, unsigned short);
int make_tac_gripper(gripper_t &, unsigned short);
int make_bf1_gripper(gripper_t &, unsigned short);
int make_gun_grip(gripper_t &, unsigned short);

#endif
