#ifndef GSM_H
#define GSM_H

#include <plib/sg.h>
#include "file.h"
#include "bone.h"
#include "assignment.h"
#include "position.h"
#include "blended.h"
#include "uv.h"
#include "vertex.h"
#include "triangle.h"
#include "group.h"
#include "stl.h"
#include "texture.h"
#include "gl_texture.h"
#include "material.h"
#include "gripper.h"

#define GSM_MAGIC "\x72\xf6\x63\x1e\x5e\x47\xd2\x11\x87\x99\x00\x20\xaf\xe6\x36\xee"

typedef struct {
  unsigned short need_hack;
  unsigned short version;
  unsigned short name_length;
  char *name;
  unsigned short num_bones;
  bone_t *bones;
  unsigned short num_assignments;
  assignment_t *assignments;
  unsigned short num_positions;
  position_t *positions;
  unsigned short num_blended;
  unsigned int blended_length;
  blended_t *blended;
  unsigned short num_vertices;
  vertex_t *vertices;
  unsigned short num_uvs;
  uv_t *uvs;
  unsigned short num_triangles;
  triangle_t *triangles;
  unsigned short num_groups;
  group_t *groups;
  unsigned int stl_length;
  unsigned short num_stls;
  stl_t *stls;
  unsigned short num_textures;
  texture_t *textures;
  unsigned short num_materials;
  material_t *materials;
  unsigned short num_grips;
  gripper_t *grips;
  unsigned short num_grippers;
  gripper_t *grippers;
  unsigned short dirname_length;
  char *dirname;
  char *type;
  texture_data_t gl_textures;
} gsm_t;

int read_gsm(gsm_t &, char *);
int write_gsm(gsm_t &, char *);
char *classify_gsm(gsm_t &);
void cleanup_gsm(gsm_t *);

#endif
