#ifndef GUI_H
#define GUI_H

#ifdef WINDOWS2000_TRANSPARENCY_DOES_NOT_SUCK
#define _WIN32_WINNT 0x0500
#endif
#include <windows.h>
#include <SDL/SDL.h>
#include <SDL/SDL_syswm.h>
#include <SDL/SDL_version.h>
#include <plib/pu.h>
#include <string>
#include "file.h"
#include "gsm.h"
#include "gsa.h"
#include "ms3d.h"
#include "ms3d_to_gsm.h"
#ifdef _MSC_VER
#include "resource.h"
#endif

#define LOADING_NOTHING 0
#define LOADING_MESH 1
#define LOADING_ANIMATION 2
#define LOADING_BACKGROUND 3

#define GUI_NEXT_FRAME_KEY SDLK_RIGHT
#define GUI_PREV_FRAME_KEY SDLK_LEFT
#define GUI_PAUSE_KEY SDLK_SPACE
#define GUI_FORWARD_KEY SDLK_w
#define GUI_BACKWARD_KEY SDLK_s
#define GUI_LEFT_KEY SDLK_a
#define GUI_RIGHT_KEY SDLK_d
#define GUI_UP_KEY SDLK_r
#define GUI_DOWN_KEY SDLK_f
#define GUI_LOAD_MESH_KEY SDLK_m
#define GUI_LOAD_ANIMATION_KEY SDLK_n
#define GUI_LOAD_BACKGROUND_KEY SDLK_b
#define GUI_TEXTURES_KEY SDLK_t
#define GUI_RELOAD_TEXTURES_KEY SDLK_v
#define GUI_MESH_KEY SDLK_1
#define GUI_BONES_KEY SDLK_2
#define GUI_AA_KEY SDLK_3
#define GUI_WIREFRAME_KEY SDLK_4
#define GUI_SHADED_KEY SDLK_5
#define GUI_TEXTURED_KEY SDLK_6
#define GUI_BACKGROUND_KEY SDLK_7
#define GUI_NORMALS_KEY SDLK_8
#define MIDDLE_BUTTON_EMULATION_KEY SDLK_LALT

#ifdef _MSC_VER
void gui_win32_paint(HWND, HDC, HBITMAP, int);
int CALLBACK gui_win32_mesh(HWND, UINT, WPARAM, LPARAM);
int CALLBACK gui_win32_animation(HWND, UINT, WPARAM, LPARAM);
int CALLBACK gui_win32_textures(HWND, UINT, WPARAM, LPARAM);
int CALLBACK gui_win32_menu(HWND, UINT, WPARAM, LPARAM);
void gui_generate_textures_list(gsm_t *, int, int *);
void gui_replace_textures(gsm_t *);
void gui_browse_for_texture();
void gui_take_screenshot();
int gui_spawn_textures_window(HWND);
HWND gui_get_listbox();
#endif
void gui_update_display_options();

void gui_load_mesh();
void gui_save_mesh(gsm_t *);
void gui_remove_mesh(gsm_t *);
void gui_load_animation();
void gui_remove_animation(gsa_t *);
void gui_load_background();
void gui_reload_textures(gsm_t *);
void gui_show_textures(gsm_t *);
void gui_toggle_shading();
void gui_toggle_wireframe();
void gui_toggle_texturing();
void gui_toggle_lighting();
void gui_toggle_background();
void gui_toggle_mesh();
void gui_toggle_bones();
void gui_toggle_aa();
void gui_toggle_normals();
void gui_set_frame_number();
void gui_next_frame();
void gui_prev_frame();
void setup_gui();
void cleanup_gui();

#endif
