#include "material.h"
#include <furrycat/str.h>

void cleanup_materials(unsigned short num_materials, material_t *materials) {
  if (! num_materials || ! materials) return;
  for (unsigned short i = 0; i < num_materials; i++) {
    material_t &material = materials[i];
    if (material.name_length && material.name) delete[] material.name;
    material.name_length = 0; material.name = 0;
    if (material.num_maps && material.maps) delete[] material.maps;
    material.num_maps = 0; material.maps = 0;
  }
  delete[] materials;
}

int magic_material_name(material_t *material) {
  if (! material) return 0;
  if (! material->name) return 0;
  if (! *material->name) return 0;

  if (str_equiv(material->name, "FLASHLIGHT")) return 1;
  if (str_equiv(material->name, "MUZZLE")) return 2;

  return 0;
}
