#ifndef MATERIAL_H
#define MATERIAL_H

#include <plib/sg.h>
#include <GL/gl.h>

typedef struct {
  unsigned short type;
  unsigned short texture_id;
} map_t;

typedef struct {
  unsigned short name_length;
  char *name;
  unsigned short num_maps;
  unsigned short type;
  map_t *maps;
  sgVec3 diffuse;
  sgVec3 ambient;
  sgVec3 specularity;
  float transparency;
  float opacity_falloff;
  char twosided;
  float self_illumination;
  float shininess;
  float shine_strength;
  GLfloat gl_opacity;
  GLint face;
  sgVec3 gl_diffuse;
  sgVec3 gl_ambient;
  sgVec3 gl_specularity;
  sgVec3 gl_emission;
  GLfloat gl_shininess;
} material_t;

void cleanup_materials(unsigned short, material_t *);
int magic_material_name(material_t *);

#endif
